local AceGUI = LibStub("AceGUI-3.0")

local labelFrame1;
local labelFrame2;
local labelFrame3;
local labelFrame4;

local label1;
local label2;
local label3;
local label4;

local whispType;

function MorthalinRaidTools:ConstructWhisperer(object, text, typ)
	if(self.ui.whispFrame == nil) then
		local FrameBackdrop = {
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 32, edgeSize = 16,
			insets = { left = 5, right = 5, top = 5, bottom = 5 }
		}
		
		self.ui.whispFrame = CreateFrame("Frame",nil,object.frame);
		self.ui.whispFrame:SetFrameStrata("TOOLTIP");
		self.ui.whispFrame:SetWidth(150);
		self.ui.whispFrame:SetHeight(64);

		self.ui.whispFrame:EnableMouse(true);
		self.ui.whispFrame:SetMovable(false);
		self.ui.whispFrame:SetResizable(false);
		self.ui.whispFrame:SetBackdrop(FrameBackdrop);
		self.ui.whispFrame:SetBackdropColor(0, 0, 0, 1);
		self.ui.whispFrame:SetToplevel(true);
		
		self.ui.whispFrame:SetPoint("TOPLEFT", (self.ui.whispFrame:GetWidth() * (-1)), 0);
	end
	whispType = typ;
	local texts = self:FindPlayers(text);
	self:SetLabels(texts);
	if(texts ~= nil and #texts ~= 0) then
		self.ui.whispFrame:Show();
	else
		self.ui.whispFrame:Hide();
	end
end

function MorthalinRaidTools:HideWhisperer()
	if(self.ui.whispFrame ~= nil) then
		self.ui.whispFrame:Hide();
		self.ui.whispFrame = nil;
	end
end

function MorthalinRaidTools:WhispererVisible()
	if(self.ui.whispFrame == nil) then
		return false;
	else
		return self.ui.whispFrame:IsVisible();
	end
end

function MorthalinRaidTools:SetLabels(texts)
	local height = 7;
	local maxWidth = 0;
	if(texts ~= nil) then
		if(#texts > 0) then
			if(labelFrame1 ~= nil) then
				labelFrame1:Hide();
				labelFrame1 = nil;
			end
			labelFrame1 = CreateFrame("Frame",nil,self.ui.whispFrame);
			label1 = labelFrame1:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
			label1:SetText(texts[1].text);
			labelFrame1:SetHeight(label1:GetHeight());
			labelFrame1:SetWidth(label1:GetWidth());
			labelFrame1:ClearAllPoints();
			labelFrame1:SetPoint("TOPLEFT", 7, height * (-1));
			label1:ClearAllPoints();
			label1:SetPoint("TOPLEFT");
			height = height + label1:GetHeight();
			if(maxWidth < label1:GetWidth()) then
				maxWidth = label1:GetWidth();
			end
			
			local highlight = labelFrame1:CreateTexture(nil, "HIGHLIGHT")
			highlight:SetColorTexture(1, 1, 1, 0.2);
			highlight:SetAllPoints();
			highlight:SetBlendMode("ADD");
			
			labelFrame1:SetScript("OnMouseDown", function()
				if(whispType == 1) then
					self:WhispererAddOnBench(label1:GetText())
				elseif(whispType == 2) then
					MorthalinRaidTools:AddHistoryBench(string.sub(label1:GetText(), 11, -1));
				elseif(whispType == 3) then
					MorthalinRaidTools:AddAlt(string.sub(label1:GetText(), 11, -1));
				elseif(whispType == 4) then
					MorthalinRaidTools:ReplacePlayer(string.sub(label1:GetText(), 11, -1));
				elseif(whispType == 5) then
					MorthalinRaidTools:AddPlayerSchedule(string.sub(label1:GetText(), 11, -1));
				elseif(whispType == 6) then
					MorthalinRaidTools:SetPlayerName(string.sub(label1:GetText(), 11, -1));
				end
			end);
			labelFrame1:Show();
		else
			if(labelFrame1 ~= nil) then
				labelFrame1:Hide();
			end
		end
		if(#texts > 1) then
			if(labelFrame2 ~= nil) then
				labelFrame2:Hide();
				labelFrame2 = nil;
			end
			labelFrame2 = CreateFrame("Frame",nil,self.ui.whispFrame);
			label2 = labelFrame2:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
			label2:SetText(texts[2].text);
			labelFrame2:SetHeight(label2:GetHeight());
			labelFrame2:SetWidth(label2:GetWidth());
			labelFrame2:ClearAllPoints();
			labelFrame2:SetPoint("TOPLEFT", 7, height * (-1));
			label2:ClearAllPoints();
			label2:SetPoint("TOPLEFT");
			height = height + label2:GetHeight();
			if(maxWidth < label2:GetWidth()) then
				maxWidth = label2:GetWidth();
			end
			
			local highlight = labelFrame2:CreateTexture(nil, "HIGHLIGHT")
			highlight:SetColorTexture(1, 1, 1, 0.2);
			highlight:SetAllPoints();
			highlight:SetBlendMode("ADD");
			
			labelFrame2:SetScript("OnMouseDown", function()
				if(whispType == 1) then
					self:WhispererAddOnBench(label2:GetText())
				elseif(whispType == 2) then
					MorthalinRaidTools:AddHistoryBench(string.sub(label2:GetText(), 11, -1));
				elseif(whispType == 3) then
					MorthalinRaidTools:AddAlt(string.sub(label2:GetText(), 11, -1));
				elseif(whispType == 4) then
					MorthalinRaidTools:ReplacePlayer(string.sub(label2:GetText(), 11, -1));
				elseif(whispType == 5) then
					MorthalinRaidTools:AddPlayerSchedule(string.sub(label2:GetText(), 11, -1));
				elseif(whispType == 6) then
					MorthalinRaidTools:SetPlayerName(string.sub(label2:GetText(), 11, -1));
				end
			end)
			labelFrame2:Show();
		else
			if(labelFrame2 ~= nil) then
				labelFrame2:Hide();
			end
		end
		if(#texts > 2) then
			if(labelFrame3 ~= nil) then
				labelFrame3:Hide();
				labelFrame3 = nil;
			end
			labelFrame3 = CreateFrame("Frame",nil,self.ui.whispFrame);
			label3 = labelFrame3:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
			label3:SetText(texts[3].text);
			labelFrame3:SetHeight(label3:GetHeight());
			labelFrame3:SetWidth(label3:GetWidth());
			labelFrame3:ClearAllPoints();
			labelFrame3:SetPoint("TOPLEFT", 7, height * (-1));
			label3:ClearAllPoints();
			label3:SetPoint("TOPLEFT");
			height = height + label3:GetHeight();
			if(maxWidth < label3:GetWidth()) then
				maxWidth = label3:GetWidth();
			end
			
			local highlight = labelFrame3:CreateTexture(nil, "HIGHLIGHT")
			highlight:SetColorTexture(1, 1, 1, 0.2);
			highlight:SetAllPoints();
			highlight:SetBlendMode("ADD");
			
			labelFrame3:SetScript("OnMouseDown", function()
				if(whispType == 1) then
					self:WhispererAddOnBench(label3:GetText())
				elseif(whispType == 2) then
					MorthalinRaidTools:AddHistoryBench(string.sub(label3:GetText(), 11, -1));
				elseif(whispType == 3) then
					MorthalinRaidTools:AddAlt(string.sub(label3:GetText(), 11, -1));
				elseif(whispType == 4) then
					MorthalinRaidTools:ReplacePlayer(string.sub(label3:GetText(), 11, -1));
				elseif(whispType == 5) then
					MorthalinRaidTools:AddPlayerSchedule(string.sub(label3:GetText(), 11, -1));
				elseif(whispType == 6) then
					MorthalinRaidTools:SetPlayerName(string.sub(label3:GetText(), 11, -1));
				end
			end)
			labelFrame3:Show();
		else
			if(labelFrame3 ~= nil) then
				labelFrame3:Hide();
			end
		end
		if(#texts > 3) then
			if(labelFrame4 ~= nil) then
				labelFrame4:Hide();
				labelFrame4 = nil;
			end
			labelFrame4 = CreateFrame("Frame",nil,self.ui.whispFrame);
			label4 = labelFrame4:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
			label4:SetText(texts[4].text);
			labelFrame4:SetHeight(label4:GetHeight());
			labelFrame4:SetWidth(label4:GetWidth());
			labelFrame4:ClearAllPoints();
			labelFrame4:SetPoint("TOPLEFT", 7, height * (-1));
			label4:ClearAllPoints();
			label4:SetPoint("TOPLEFT");
			height = height + label4:GetHeight();
			if(maxWidth < label4:GetWidth()) then
				maxWidth = label4:GetWidth();
			end
			
			local highlight = labelFrame4:CreateTexture(nil, "HIGHLIGHT")
			highlight:SetColorTexture(1, 1, 1, 0.2);
			highlight:SetAllPoints();
			highlight:SetBlendMode("ADD");
			
			labelFrame4:SetScript("OnMouseDown", function()
				if(whispType == 1) then
					self:WhispererAddOnBench(label4:GetText())
				elseif(whispType == 2) then
					MorthalinRaidTools:AddHistoryBench(string.sub(label4:GetText(), 11, -1));
				elseif(whispType == 3) then
					MorthalinRaidTools:AddAlt(string.sub(label4:GetText(), 11, -1));
				elseif(whispType == 4) then
					MorthalinRaidTools:ReplacePlayer(string.sub(label4:GetText(), 11, -1));
				elseif(whispType == 5) then
					MorthalinRaidTools:AddPlayerSchedule(string.sub(label4:GetText(), 11, -1));
				elseif(whispType == 6) then
					MorthalinRaidTools:SetPlayerName(string.sub(label4:GetText(), 11, -1));
				end
			end)
			labelFrame4:Show();
		else
			if(labelFrame4 ~= nil) then
				labelFrame4:Hide();
			end
		end
	end
	self.ui.whispFrame:SetHeight(height + 7);
	self.ui.whispFrame:SetWidth(maxWidth + 14);
	if(labelFrame1 ~= nil) then
		labelFrame1:SetWidth(maxWidth);
	end
	if(labelFrame2 ~= nil) then
		labelFrame2:SetWidth(maxWidth);
	end
	if(labelFrame3 ~= nil) then
		labelFrame3:SetWidth(maxWidth);
	end
	if(labelFrame4 ~= nil) then
		labelFrame4:SetWidth(maxWidth);
	end
	self.ui.whispFrame:ClearAllPoints();
	self.ui.whispFrame:SetPoint("TOPLEFT", (self.ui.whispFrame:GetWidth() * (-1)), 0);
end